////////////////////////////////////////////////////////////
// ɗWv

package net.minecraft.src;

import java.util.Random;

public class EntityDollAISwimming extends EntityAIBase
{
    private EntityDoll theDoll;

    public EntityDollAISwimming(EntityDoll entitydoll)
    {
        theDoll = entitydoll;
        setMutexBits(0x4);
        entitydoll.getNavigator().setCanSwim(true);
    }

    @Override
    public boolean shouldExecute()
    {
        return theDoll.isInWater() || theDoll.handleLavaMovement();
    }

    @Override
    public void updateTask()
    {
        if (theDoll.getRNG().nextFloat() < 0.8F)
        {
            theDoll.getJumpHelper().setJumping();
            if(theDoll.isStandbyMode())
            {
                theDoll.setPatrolMode();
            }
        }
    }
}
