package net.minecraft.src;

import java.util.Map;
import java.util.Random;
import net.minecraft.client.Minecraft;

public class mod_Touhou_Alice_Dolls extends BaseMod
{
    // o[W
    @Override
    public String getVersion()
    {
        return "ver1.4.5-med";
    }

    // MODǂݍݎɌĂ΂
    @Override
    public void load()
    {
        // GeBeB̓o^
        ModLoader.registerEntityID(EntityDoll.class, "Alice's Doll", dollEntityID, 0xffffff, 0x0000ff);
        ModLoader.addEntityTracker( this, EntityDoll.class, dollEntityID, 64, 1, true );

        // h[RA
        dollCore = new ItemDollCore(dollCoreID)
            .setItemName("core")
            .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollcore.png"))
            .setCreativeTab(CreativeTabs.tabTools);
        ModLoader.addName(this.dollCore, "dollCore");
        ModLoader.addName(this.dollCore, "ja_JP", "h[RA");
        ModLoader.addRecipe(
            new ItemStack(this.dollCore, 1),
            new Object[]{
                "# $",
                "#d$",
                " # ",
                Character.valueOf('#'), Item.redstone,
                Character.valueOf('$'), new ItemStack(Item.dyePowder, 1, 4),
                Character.valueOf('d'), Item.diamond
            });
        
        // f̐l`
        if(dollBareID != 0)
        {
            dollBare = new ItemDoll(dollBareID)
                .setItemName("dollbare")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollbare_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollBare, "dollBare");
            ModLoader.addName(this.dollBare, "ja_JP", "f̐l`");
            ModLoader.addRecipe(
                new ItemStack(this.dollBare, 1),
                new Object[]{
                    " W ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                });
        }
        
        // Cl`
        if(dollShanghaiID != 0)
        {
            dollShanghai = new ItemDoll(dollShanghaiID)
                .setItemName("dollshanghai")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollshanghai_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollShanghai, "dollShanghai");
            ModLoader.addName(this.dollShanghai, "ja_JP", "Cl`");
            ModLoader.addRecipe(
                new ItemStack(this.dollShanghai, 1),
                new Object[]{
                    "SW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('S'), Item.swordGold,
                });
        }

        // Hl`
        if(dollHoraiID != 0)
        {
            dollHorai = new ItemDoll(dollHoraiID)
                .setItemName("dollhorai")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollhorai_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollHorai, "dollHorai");
            ModLoader.addName(this.dollHorai, "ja_JP", "Hl`");
            ModLoader.addRecipe(
                new ItemStack(this.dollHorai, 1),
                new Object[]{
                    "PW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('P'), Item.pickaxeGold,
                });
        }

        // ]ːl`
        if(dollOoedoID != 0)
        {
            dollOoedo = new ItemDoll(dollOoedoID)
                .setItemName("dollooedo")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollooedo_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollOoedo, "dollOoedo");
            ModLoader.addName(this.dollOoedo, "ja_JP", "]ːl`");
            ModLoader.addRecipe(
                new ItemStack(this.dollOoedo, 1),
                new Object[]{
                    "TW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('T'), Block.tnt,
                });
        }

        // Il`
        if(dollRussiaID != 0)
        {
            dollRussia = new ItemDoll(dollRussiaID)
                .setItemName("dollrussia")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollrussia_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollRussia, "dollRussia");
            ModLoader.addName(this.dollRussia, "ja_JP", "Il`");
            ModLoader.addRecipe(
                new ItemStack(this.dollRussia, 1),
                new Object[]{
                    "CW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('C'), Block.chest,
                });
        }

        // ƈl`
        if(dollGermanyID != 0)
        {
            dollGermany = new ItemDoll(dollGermanyID)
                .setItemName("dollgermany")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollgermany_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollGermany, "dollGermany");
            ModLoader.addName(this.dollGermany, "ja_JP", "ƈl`");
            ModLoader.addRecipe(
                new ItemStack(this.dollGermany, 1),
                new Object[]{
                    "AW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('A'), Item.axeGold,
                });
        }

        // ϓ֐l`
        if(dollLondonID != 0)
        {
            dollLondon = new ItemDoll(dollLondonID)
                .setItemName("dolllondon")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dolllondon_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollLondon, "dollLondon");
            ModLoader.addName(this.dollLondon, "ja_JP", "ϓ֐l`");
            ModLoader.addRecipe(
                new ItemStack(this.dollBare, 1),
                new Object[]{
                    "EW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('E'), Item.eyeOfEnder,
                });
        }

        // l`
        if(dollMarisaID != 0)
        {
            dollMarisa = new ItemDoll(dollMarisaID)
                .setItemName("dollmarisa")
                .setIconIndex(ModLoader.addOverride("/gui/items.png","/dolls/dollmrs_item.png"))
                .setCreativeTab(CreativeTabs.tabTools);;
            ModLoader.addName(this.dollMarisa, "dollMarisa");
            ModLoader.addName(this.dollMarisa, "ja_JP", "l`");
            ModLoader.addRecipe(
                new ItemStack(this.dollBare, 1),
                new Object[]{
                    "MW ",
                    "WHW",
                    " W ",
                    Character.valueOf('W'), Block.cloth,
                    Character.valueOf('H'), this.dollCore,
                    Character.valueOf('M'), Block.mushroomRed,
                });
        }

        // 萔
        EntityDollAIExplode.targetEntity = targetEntity;
        EntityDollAIExplode.searchRange = searchRange;
        EntityDollAIExplode.searchHeight = searchHeight;
        EntityDollAIExplode.explodeStrength = explodeStrength;

        EntityDollAISearchTarget.searchEntity = searchEntity;
        EntityDollAISearchTarget.targetEntity = targetEntity;
        EntityDollAISearchTarget.searchRange = searchRange;
        EntityDollAISearchTarget.searchHeight = searchHeight;
        
        EntityDollAIAttackTarget.targetEntity = targetEntity;
        EntityDollAIAttackTarget.attackStrength = attackStrength;
        EntityDollAICollectItem.searchRange = searchRange;
        EntityDollAICollectItem.searchHeight = searchHeight;
        EntityDollAICollectItem.canCollectRange = canCollectRange;

        EntityDollAIMineBlock.targetBlock = targetBlock;
        EntityDollAIMineBlock.mineRange = mineRange;
        EntityDollAIMineBlock.mineSpeed = mineSpeed;

        EntityDollAICutTree.logBlock = logBlock;
        EntityDollAICutTree.leavesBlock = leavesBlock;
        EntityDollAICutTree.cutRange = cutRange;
        EntityDollAICutTree.cutSpeed = cutSpeed;
    }

    // _̒ǉ
    @Override
    public void addRenderer(Map renderers)
    {
        renderers.put(EntityDoll.class, new RenderDoll());
    }

    // NCAgɂl`X|[鏈
    @Override
    public Entity spawnEntity(int id, World worldObj, double x, double y, double z)
    {
        if(id == dollEntityID)
        {
            return new EntityDoll( worldObj, x, y, z );
        }
        else
        {
            return null;
        }
    }

    // T[o[ɐl`̃X|[v
    @Override
    public Packet23VehicleSpawn getSpawnPacket(Entity entity, int id)
    {
        if(entity instanceof EntityDoll)
        {
            return new Packet23VehicleSpawn( entity, dollEntityID );
        }
        else
        {
            return null;
        }
    }

    ////////////////////////////////////////////////////////////////////////////
    // ǉubNEACe

    public static Item dollCore;
    public static Item dollShanghai;
    public static Item dollHorai;
    public static Item dollOoedo;
    public static Item dollRussia;
    public static Item dollGermany;
    public static Item dollLondon;
    public static Item dollMarisa;
    public static Item dollBare;
    
    ////////////////////////////////////////////////////////////////////////////
    // vpeB

    @MLProp(min=0, max=127)
    static int dollEntityID = 81;

    @MLProp(min=0, max=32000)
	public static int dollCoreID = 392;

    @MLProp(min=0, max=32000)
	public static int dollShanghaiID = 393;
    
	@MLProp(min=0, max=32000)
	public static int dollHoraiID = 394;
    
	@MLProp(min=0, max=32000)
	public static int dollOoedoID = 395;
    
	@MLProp(min=0, max=32000)
	public static int dollRussiaID = 396;
    
	@MLProp(min=0, max=32000)
	public static int dollGermanyID = 397;
    
	@MLProp(min=0, max=32000)
	public static int dollLondonID = 398;
    
	@MLProp(min=0, max=32000)
	public static int dollBareID = 399;
    
	@MLProp(min=0, max=32000)
	public static int dollMarisaID = 400;


    @MLProp(min=0D, max=32D)
    public static double searchRange = 16D;
    
    @MLProp(min=0D, max=8D)
    public static double searchHeight = 4D;

    @MLProp(min=0F, max=16F)
    public static float canCollectRange = 3F;

    @MLProp
    public static String searchEntity = "\\A(?!Alice's Doll).*";

    @MLProp
    public static String targetEntity = "Zombie|Skeleton|Creeper|Spider|Slime|Enderman|Silverfish|Blaze";

    @MLProp(min=1f, max=18f)
    public static float explodeStrength = 3f;
    
    @MLProp(min=0, max=100)
    public static int attackStrength = 2;

    @MLProp
    public static String targetBlock = "ore.+";
    
    @MLProp(min=1, max=8)
    public static int mineRange = 3;

    @MLProp(min=1D, max=10D)
    public static double mineSpeed = 2.5D;

    @MLProp
    public static String logBlock = "log|mushroom";

    @MLProp
    public static String leavesBlock = "leaves|mushroom|vine";

    @MLProp(min=1, max=12)
    public static int cutRange = 5;

    @MLProp(min=1D, max=10D)
    public static double cutSpeed = 2.5D;
}
